	.macro	sincosXYZ,angles,sin,cos

	lq	  			a_const,i_angConsts(vi00)
	lq	  			s_taylor,i_sinTaylor(vi00)
	lq	  			c_taylor,i_cosTaylor(vi00)

	mul.xyz   	ssign,\angles,a_const[x]		; max value
	mini.xyz		ssign,ssign,vf00[x]       		; clamp above 0.0
	loi	      -2.0
	max.xyz		ssign,ssign,i	 		; clamp to -2 below
	add.xyz		ssign,ssign,vf00[w]		; now.. -1 or 1	 !

	abs.xyz		\angles,\angles			; abs value
	ftoi0.xyz	iang,\angles			; integer parts
	
	iaddiu 		three,vi00,3
	
	mtir	      x_int,iang[x]
	iand   		x_int,x_int,three
	lq.x   		flip,i_FBT(x_int)
	lq.x   		sin_sign,i_SST(x_int)
	lq.x  		cos_sign,i_CST(x_int)
	
	mtir	      y_int,iang[y]
	iand   		y_int,y_int,three
	lq.y   		flip,i_FBT(y_int)
	lq.y   		sin_sign,i_SST(y_int)
	lq.y  		cos_sign,i_CST(y_int)
	
	mtir   		z_int,iang[z]
	iand   		z_int,z_int,three
	lq.z   		flip,i_FBT(z_int)
	lq.z 	     	sin_sign,i_SST(z_int)
	lq.z  		cos_sign,i_CST(z_int)
	
	mul.xyz		sin_sign,ssign,sin_sign
	
	itof0.xyz	ifang,iang
	sub.xyz		\angles,\angles,ifang	   		; angle 0-1
	
	mul.xyz		ang2,\angles,\angles
	mul.xyz		ang3,ang2,\angles
	mul.xyz		ang4,ang2,ang2
	mul.xyz		ang5,ang3,ang2
	mul.xyz		ang6,ang3,ang3
	mul.xyz		ang7,ang3,ang4
	mul.xyz		ang8,ang4,ang4
	mul.xyz		ang9,ang5,ang4
	mul.xyz		ang10,ang5,ang5
	
	mula.xyz		acc,\angles,a_const[z]
	madda.xyz	acc,ang3,s_taylor[x]
   madda.xyz	acc,ang5,s_taylor[y]
   madda.xyz	acc,ang7,s_taylor[z]
   madd.xyz		tsin,ang9,s_taylor[w]
	
	adda.xyz   	acc,vf00,vf00[w]
	madda.xyz	acc,ang2,a_const[w]
	madda.xyz	acc,ang4,c_taylor[x]
	madda.xyz	acc,ang6,c_taylor[y]
	madda.xyz	acc,ang8,c_taylor[z]
	madd.xyz		tcos,ang10,c_taylor[w]
	

	sub.xyz		mflip,flip,vf00[w]
	mula.xyz   	acc,tcos,flip  		; flip=1.0 if flip, else 0.0
	msub.xyz   	\sin,tsin,mflip
	
	mula.xyz   	acc,tsin,flip  		; flip=1.0 if flip, else 0.0
	msub.xyz   	\cos,tcos,mflip 		
	
	mul.xyz		\sin,\sin,sin_sign	; set correct signs
	mul.xyz		\cos,\cos,cos_sign







		.endm

